/*
 * File:   main.c
 * Author: Adiministrateur
 * mode fonctionnement continu
 * Created on 2 mars 2015, 16:34
 */

// CONFIG
#pragma config FOSC = INTOSCIO  // Oscillator Selection bits (INTOSCIO oscillator: I/O function on RA4/OSC2/CLKOUT pin, I/O function on RA5/OSC1/CLKIN)
#pragma config WDTE = OFF       // Watchdog Timer Enable bit (WDT disabled)
#pragma config PWRTE = ON       // Power-up Timer Enable bit (PWRT enabled)
#pragma config MCLRE = ON      // MCLR Pin Function Select bit (MCLR pin function is digital input, MCLR internally tied to VDD)
#pragma config CP = OFF         // Code Protection bit (Program memory code protection is disabled)
#pragma config CPD = OFF        // Data Code Protection bit (Data memory code protection is disabled)
#pragma config BOREN = ON       // Brown Out Detect (BOR enabled)
#pragma config IESO = OFF        // Internal External Switchover bit (Internal External Switchover mode is enabled)
#pragma config FCMEN = OFF       // Fail-Safe Clock Monitor Enabled bit (Fail-Safe Clock Monitor is enabled)
#define _XTAL_FREQ 8000000

#include <xc.h>
#include <stdio.h>
#include <stdlib.h>

#define Bp      GPIObits.GP2
#define led     GPIObits.GP4
#define cmde    GPIObits.GP1
#define mode    GPIObits.GP0


volatile char choix = 1,adresse;
void my_delais(unsigned int nbms);
void interrupt Bouton()
{
    if(INTF)                 
    {
    __delay_ms(10);
    if (!Bp)                //bouton presse ?
    {
        choix++;            //incremente le choix
        if(choix>12)
        {
            choix = 0;
        }
     
    }
    eeprom_write(adresse, choix);
    INTF = 0;           //RAZ du flag INTF
    }
  
}


void main(void) {
    unsigned char cmpt;
    OSCCON = 0b01110111;    //configuration oscillateur int 4Mhz
    ANSEL = 0;              //toutes les pins mode digital
    GPIO = 0b00010100;
    TRISIO = 0b11101101;    //GP1 et GP4 = sortie, GP0 en entre
    choix =0;
    INTEDG =0;              // int sur niveau descendant
    INTE = 1;               // autorise les interruptions externes
    GIE = 1;                // interruption gnrale autorise
    adresse = 0x80;
    choix = eeprom_read (adresse);    // lecture contenu eeprom
    if(choix>12)
    {
        choix=0;
        eeprom_write(adresse, choix);
    }
    while(1)
    {

    switch(choix)
    {
        case 0:                 // 1 eclat toutes les 1s
            led = 0;
            cmde = 1;
            my_delais(100);
            led = 1;
            cmde = 0;
            my_delais(900);
        break;
        case 1:                 // 1 eclat toutes les 5s
            led = 0;
            cmde = 1;
            my_delais(100);
            led = 1;
            cmde = 0;
            my_delais(4900);
         break;
         case 2:                 // 2 eclats groups toutes les 10s
            for (cmpt=0;cmpt<2;cmpt++)
            {
                led = 0;
                cmde = 1;
                my_delais(100);
                led = 1;
                cmde = 0;
                my_delais(80);
            }
            my_delais(9640);
        break;
        case 3:                 // 3 eclats groups toutes les 12s
            for (cmpt=0;cmpt<3;cmpt++)
            {
                led = 0;
                cmde = 1;
                my_delais(100);
                led = 1;
                cmde = 0;
                my_delais(80);
            }
            my_delais(11460);
        break;
        case 4:                // 3 eclats groups toutes les 20s
            for (cmpt=0;cmpt<3;cmpt++)
            {
                led = 0;
                cmde = 1;
                my_delais(100);
                led = 1;
                cmde = 0;
                my_delais(80);
            }
            my_delais(19460);
        break;
        case 5:                // 4 eclats groups toutes les 10s
            for (cmpt=0;cmpt<4;cmpt++)
            {
                led = 0;
                cmde = 1;
                my_delais(100);
                led = 1;
                cmde = 0;
                my_delais(80);
            }
            my_delais(9280);
        break;
        case 6:               // 4 eclats groups toutes les 15s
            for (cmpt=0;cmpt<4;cmpt++)
            {
                led = 0;
                cmde = 1;
                my_delais(100);
                led = 1;
                cmde = 0;
                my_delais(80);
            }
            my_delais(14280);
        break;
        case 7:               // 4 eclats groups toutes les 25s
            for (cmpt=0;cmpt<4;cmpt++)
            {
                led = 0;
                cmde = 1;
                my_delais(100);
                led = 1;
                cmde = 0;
                my_delais(80);
            }
            my_delais(24280);
        break;
        case 8:               // 9 eclats groups toutes les 10s
            for (cmpt=0;cmpt<9;cmpt++)
            {
                led = 0;
                cmde = 1;
                my_delais(100);
                led = 1;
                cmde = 0;
                my_delais(40);
            }
            my_delais(8380);
        break;
        case 9:                // OUEST : 9 eclats de 100ms + 1s off
            for (cmpt=0;cmpt<9;cmpt++)
            {
                led = 0;
                cmde = 1;
                my_delais(100);
                led = 1;
                cmde = 0;
                my_delais(80);
            }
            my_delais(1000);
        break;
        case 10:               // EST : 3 eclats de 100ms + 4,7s off
            for (cmpt=0;cmpt<3;cmpt++)
            {
                led = 0;
                cmde = 1;
                my_delais(100);
                led = 1;
                cmde = 0;
                my_delais(80);
            }
            my_delais(4700);
        break;
        case 11:                //NORD : scintillement continu
            for (cmpt=0;cmpt<9;cmpt++)
            {
                led = 0;
                cmde = 1;
                my_delais(100);
                led = 1;
                cmde = 0;
                my_delais(80);
            }
        break;
        case 12:            // SUD : 6 * 100ms on + 1s on + 8,6s off
            for (cmpt=0;cmpt<6;cmpt++)
            {
                led = 0;
                cmde = 1;
                my_delais(100);
                led = 1;
                cmde = 0;
                my_delais(80);
            }
            led = 0;
            cmde = 1;
            my_delais(1000);
            led = 1;
            cmde = 0;
            my_delais(8600);
        break;
     }
    
    
    }
    
}
/*########################################################################*/

void my_delais(unsigned int nbms)
{
    for (int count=0; count<nbms; count++) __delay_ms(1);
}